import {BasePhysics, IPhysicsObject} from '../common/physics';
import type {World} from './world';
import * as TWEEN from '@tweenjs/tween.js';
import type {Quaternion} from 'three';

export class Physics extends BasePhysics {
  constructor(baseWorld: World) {
    super(baseWorld);
  }

  override setPos(object: IPhysicsObject, body: IPhysicsObject) {
    new TWEEN.Tween(object.position).to(body.position, 50).start();
    new TWEEN.Tween(object.quaternion)
        .to(body.quaternion, 50)
        .onUpdate(() => (<Quaternion>object.quaternion).normalize())
        .start();
  }

  // @ts-ignore
  update(delta: number) {
    TWEEN.update();
  }
}