import type {IPhysicsObject} from './physics.js';
import type {IBaseTroonia} from './troonia.js';
import type {BasePhysics} from './physics.js';
import type {TSceneObject} from './scenes.js'
import type {IPlayerData} from './player.js';

export abstract class BaseWorld {
  game: IBaseTroonia;
  objects: {[id: string]: IPhysicsObject} = {};
  players: {[id: string]: IPlayerData} = {};

  constructor(game: IBaseTroonia) {
    this.game = game;
  }
}

export interface IBaseWorld extends BaseWorld {
  physics: BasePhysics;
  addPlayer(id?: string): void;
  removePlayer(id?: string): void;
  update(delta: number): void;
  load(scene: TSceneObject[]): void;
}
