import express from 'express';
import http from 'http';
import path from 'path';
import {Server} from 'socket.io';
import {fileURLToPath} from 'url';

import {Troonia} from './troonia.js';

const port: number = 3001;

class App {
  private readonly server: http.Server;
  private readonly port: number;

  private readonly io: Server;

  constructor(port: number) {
    this.port = port;
    const app = express();

    const __filename = fileURLToPath(import.meta.url);
    const __dirname = path.dirname(__filename);

    app.use(express.static(path.join(__dirname, '../../client')));

    this.server = new http.Server(app);

    this.io = new Server(this.server);
    new Troonia(this.io);
  }

  public Start() {
    this.server.listen(this.port, () => {
      console.log(`Server listening on port ${this.port}.`);
    });
  }
}

new App(port).Start();